LIBRARY IEEE;
LIBRARY MACHXO2;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE MACHXO2.ALL;

ENTITY TOP IS
PORT(
	I_STDBY : IN STD_LOGIC;
	O_DATA : OUT STD_LOGIC;
	O_DATA_VECT : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
	I_RST : IN STD_LOGIC);
END TOP;

ARCHITECTURE BEHAV OF TOP IS
SIGNAL INT_CLK1 : STD_LOGIC;
SIGNAL INT_CLK2 : STD_LOGIC;
SIGNAL INT_SED : STD_LOGIC;
--SIGNAL SOUTVECT : STD_LOGIC_VECTOR(4 DOWNTO 0);
--SIGNAL CPT : INTEGER RANGE 0 TO 200000;
SIGNAL CPT : INTEGER RANGE 0 TO 1;
COMPONENT GENDECAL
	PORT(
		CLK : IN STD_LOGIC;
		RST : IN STD_LOGIC;
		SOUT : OUT STD_LOGIC);
END COMPONENT;

COMPONENT OSCH
PORT(
	STDBY : IN STD_LOGIC;
	OSC, SEDSTDBY : OUT STD_LOGIC);
END COMPONENT;

BEGIN
	U1 : OSCH PORT MAP(STDBY => I_STDBY, OSC => INT_CLK1, SEDSTDBY => INT_SED);
	U2 : GENDECAL PORT MAP(CLK => INT_CLK2, RST => I_RST, SOUT => O_DATA);
	
	ABAISSEUR_HORLOGE : PROCESS(INT_CLK1)
	BEGIN
		IF(INT_CLK1'EVENT AND INT_CLK1='1') THEN
			--IF(CPT=200000) THEN CPT<=0;
			--ELSE CPT<= CPT+1;
			--END IF;
			IF(CPT=1) THEN CPT <= 0;
			ELSE CPT <= CPT + 1;
			END IF;
		END IF;
	END PROCESS ABAISSEUR_HORLOGE;
	INT_CLK2 <= '1' WHEN(CPT>=1) ELSE '0';
END;